import 'package:yaz/yaz.dart';

import 'user.dart';

///
class SharedPreferencesDelegate extends StorageDelegate {
  @override
  Future<void> clear() {
    throw UnimplementedError();
  }

  @override
  Future<List<Map<String, dynamic>>?> get(String key) {
    throw UnimplementedError();
  }

  @override
  Future<void> remove(String key) {
    throw UnimplementedError();
  }

  @override
  Future<void> set(String key, List<Map<String, dynamic>> values) {
    throw UnimplementedError();
  }
}

///
class UserController extends StorageContentController<User> {
  ///
  factory UserController() => _internal;

  ///
  UserController.internal() : super(SharedPreferencesDelegate());

  static final UserController _internal = UserController.internal();

  @override
  Future<User?> contentGetter(String identifier) async {
    // ignore: avoid_print
    print("$identifier Content get from db : $identifier");
    await Future.delayed(const Duration(milliseconds: 300));
    return User(identifier, "User Of $identifier");
  }

  @override
  User fromJson(Map<String, dynamic> map) {
    return User.fromJson(map);
  }

  @override
  int get maxCount => 30;

  @override
  Duration get maxDuration => const Duration(minutes: 30);

  @override
  String get saveKey => "users";

  @override
  Map<String, dynamic> toJson(User instance) {
    return instance.toJson();
  }
}
