import 'package:flutter/material.dart';

import '../../yaz.dart';

///
abstract class ConsumerWidget extends StatefulWidget {
  ///
  const ConsumerWidget({required this.notifier, Key? key}) : super(key: key);

  ///
  final ChangeNotifier notifier;

  /// Build function that will be called when the notifier changes
  Widget build(BuildContext context);

  @override
  State<ConsumerWidget> createState() => _ConsumerState();
}

class _ConsumerState extends State<ConsumerWidget> {
  @override
  Widget build(BuildContext context) {
    return YazListenerWidget(
        changeNotifier: widget.notifier, builder: () => widget.build(context));
  }
}
